<?php
/**
 * Created by PhpStorm.
 * by Jinko Wu
 * Date: 2015/12/17
 */
function jsession_start()
{
    if(!$_COOKIE['__SESSID']) {
        jsession_regenerate_id();
    }

    return jsession_update();
}

function jsession_update($session_id=null)
{
    $session_id = $session_id === null ? $_COOKIE['__SESSID'] : $session_id;

    if($session_id == '') {
        return null;
    }

    if($session_id && $data = jsession_is_valid($session_id)) {
        jsession_save($data);
        setcookie('__SESSID', $session_id, time()+jsession_live_time());
        return $data;
    }

    return null;
}

function jsession_regenerate_id()
{
    $sessid = jsession_generate_id();

    if(jsession_id() != '' && file_exists('.sessioncache/' .jsession_id())) {
        rename('.sessioncache/' .jsession_id(), '.sessioncache/' .$sessid);
    }

    $_COOKIE['__SESSID'] = $sessid;
    setcookie('__SESSID', $sessid, time()+jsession_live_time());
}

function jsession_generate_id()
{
    return 's'.base_convert(rand(0, 9999999999).rand(0, 9999999999).rand(0, 9999999999).rand(0, 9999999999), 10, 36);
}

function jsession_id()
{
    return $_COOKIE['__SESSID'];
}

function jsession_live_time()
{
    $gc_maxlifetime = ini_get('session.gc_maxlifetime');
    $gc_maxlifetime = $gc_maxlifetime == '' ? 1440 : $gc_maxlifetime;
    return $gc_maxlifetime;
}

function jsession_is_valid($session_id)
{
    $session_id = $session_id === null ? $_COOKIE['__SESSID'] : $session_id;

    if($session_id == '') {
        return false;
    }

    if(file_exists('.sessioncache/' .$session_id)) {
        $data = unserialize(@file_get_contents('.sessioncache/' . $session_id));
        return time() <= $data['time'] ? $data['data'] : false;
    } else {
        return false;
    }
}

function jsession_data($session_id=null)
{
    $session_id = $session_id === null ? $_COOKIE['__SESSID'] : $session_id;

    if($session_id == '') {
        return null;
    }

    if($data = jsession_is_valid($session_id)) {
        return $data['data'];
    }

    return null;
}

function jsession_save($data)
{

    if(!is_dir('.sessioncache')) {
        mkdir('.sessioncache', 0777);
    }

    if($_COOKIE['__SESSID'] == '') {
        return null;
    }

    $file = '.sessioncache/'.$_COOKIE['__SESSID'];
    $fp = fopen($file , 'w');

    if(flock($fp , LOCK_EX)) {
        fwrite($fp, serialize(array('time' => time() + jsession_live_time(), 'data' => $data)));
        flock($fp, LOCK_UN);
    }

    fclose($fp);
    return $data;
}

function jsession_destory($session_id)
{
    if($session_id == '') {
        return ;
    }

    if($session_id == $_COOKIE['__SESSID']) {
        setcookie('__SESSID', '');
        $_COOKIE['__SESSID'] = null;
    }

    if(file_exists('.sessioncache/' .$session_id)) {
        @unlink('.sessioncache/' .$session_id);
    }
}